//
// PropertyPowerProduction.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PropertyPowerProduction: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var listingKeyNumeric: Double?
    public var powerProductionAnnual: Double?
    public var powerProductionKeyNumeric: Double?
    public var powerProductionSize: Double?
    public var powerProductionYearInstall: Double?
    public var listingId: String?
    public var listingKey: String?
    public var powerProductionKey: String?
    public var powerProductionAnnualStatus: String?
    public var powerProductionType: String?
    public var modificationTimestamp: Date?
    public var property: Property?

    public init(id: Int? = nil, listingKeyNumeric: Double? = nil, powerProductionAnnual: Double? = nil, powerProductionKeyNumeric: Double? = nil, powerProductionSize: Double? = nil, powerProductionYearInstall: Double? = nil, listingId: String? = nil, listingKey: String? = nil, powerProductionKey: String? = nil, powerProductionAnnualStatus: String? = nil, powerProductionType: String? = nil, modificationTimestamp: Date? = nil, property: Property? = nil) {
        self.id = id
        self.listingKeyNumeric = listingKeyNumeric
        self.powerProductionAnnual = powerProductionAnnual
        self.powerProductionKeyNumeric = powerProductionKeyNumeric
        self.powerProductionSize = powerProductionSize
        self.powerProductionYearInstall = powerProductionYearInstall
        self.listingId = listingId
        self.listingKey = listingKey
        self.powerProductionKey = powerProductionKey
        self.powerProductionAnnualStatus = powerProductionAnnualStatus
        self.powerProductionType = powerProductionType
        self.modificationTimestamp = modificationTimestamp
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case listingKeyNumeric = "ListingKeyNumeric"
        case powerProductionAnnual = "PowerProductionAnnual"
        case powerProductionKeyNumeric = "PowerProductionKeyNumeric"
        case powerProductionSize = "PowerProductionSize"
        case powerProductionYearInstall = "PowerProductionYearInstall"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case powerProductionKey = "PowerProductionKey"
        case powerProductionAnnualStatus = "PowerProductionAnnualStatus"
        case powerProductionType = "PowerProductionType"
        case modificationTimestamp = "ModificationTimestamp"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(powerProductionAnnual, forKey: .powerProductionAnnual)
        try container.encodeIfPresent(powerProductionKeyNumeric, forKey: .powerProductionKeyNumeric)
        try container.encodeIfPresent(powerProductionSize, forKey: .powerProductionSize)
        try container.encodeIfPresent(powerProductionYearInstall, forKey: .powerProductionYearInstall)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(powerProductionKey, forKey: .powerProductionKey)
        try container.encodeIfPresent(powerProductionAnnualStatus, forKey: .powerProductionAnnualStatus)
        try container.encodeIfPresent(powerProductionType, forKey: .powerProductionType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

